CREATE TABLE dbo.AllQuestions
(
	PersonID int,
	IsFeelingOkay bit,
	IsHungry bit,
	IsTired bit,
	IsWearingBlue bit
);

WITH Questions AS
(
    SELECT
        sc.name as ColumnName,
        SUBSTRING(sc.name, 3, LEN(sc.name)) as SplitColumnName      
    FROM
        sys.columns sc
        INNER JOIN sys.tables st ON sc.object_id = st.object_id
        INNER JOIN sys.schemas ss ON st.schema_id = ss.schema_id
        INNER JOIN sys.types styp ON sc.system_type_id = styp.system_type_id
    WHERE
        ss.name = 'dbo'
        and st.name = 'AllQuestions'
        and sc.name like 'Is%'
        and styp.name = 'bit'
),
SplitValues AS
(
    SELECT
        q.ColumnName,
        q.SplitColumnName,
        SUBSTRING(q.SplitColumnName, n.N, 1) as Letter,
        n.N,
        CASE WHEN BINARY_CHECKSUM(SUBSTRING(q.SplitColumnName, n.N, 1)) = BINARY_CHECKSUM(LOWER(SUBSTRING(q.SplitColumnName, n.N, 1))) THEN 0 ELSE 1 END AS IsUppercaseLetter
    FROM
        dbo.Tally n
        CROSS JOIN Questions q
    WHERE
		n.N > 0
        AND n.N <= LEN(q.SplitColumnName)
)
SELECT DISTINCT
    sv.ColumnName,
    STUFF
    (
        (
            SELECT
                CASE WHEN svi.IsUppercaseLetter = 1 AND svi.N > 1 THEN ' ' ELSE '' END + svi.Letter
            FROM
                SplitValues svi
            WHERE
                svi.ColumnName = sv.ColumnName
            ORDER BY
                svi.N
            FOR XML PATH('')
        ), 1, 0, ''
    ) as SplitColumnName
FROM
    SplitValues sv
ORDER BY
    SplitColumnName;

DROP TABLE dbo.AllQuestions;
