set statistics io on;
SET NOCOUNT ON;

--Compare results against this count to make sure 
--both return the correct number of records.
SELECT COUNT(*) FROM sys.all_objects;

/* Generate a random value for each user */
with saltchars as
(
	select
		object_id as Id,
		N,
		CHAR(ROUND(RAND(cast(abs(checksum(newid())) as int)) * 93 + 33, 0)) as randomvalue
	from 
		sys.all_objects u
		cross join dbo.Tally t
	where
		t.N between 1 and 20
)
select distinct
	Id,
	substring((select ('' + randomvalue )
				from saltchars s2 
				where s1.Id = s2.Id
				order by N 
				for xml path ( '' )
				), 1, 20) as RandomValue
from
	saltchars s1;

	
/* Now do the same with a cursor...  */
DECLARE @counter tinyint;
DECLARE @nextChar char(1);
DECLARE @randomString varchar(20);
DECLARE @objectID bigint;
declare @randomStrings table 
( 
	id bigint,
	string varchar(20) 
);

DECLARE userCursor CURSOR FOR
SELECT Object_ID
FROM sys.all_objects;

OPEN userCursor
FETCH NEXT FROM userCursor INTO @objectID;

WHILE @@FETCH_STATUS = 0
BEGIN	
	SET @counter = 1
	SET @randomString = ''

	WHILE @counter <= 20
	BEGIN
	  SELECT @nextChar = CHAR(ROUND(RAND(cast(abs(checksum(newid())) as int)) * 93 + 33, 0))
	  SELECT @randomString = @randomString + @nextChar
	  SET @counter = @counter + 1
	END
	
	insert into @randomStrings(id, string)
	select @objectID, @randomString;

	FETCH NEXT FROM userCursor INTO @objectID;
END
CLOSE userCursor;
DEALLOCATE userCursor;

select * from @randomStrings;